#include "BWT.h"
#include "MTF.h"
#include "RLE.h"
#include "ArithmeticCodec.h"


//TODO : tmpfiles
//oder stream durchreichen
//oder delete tmp1 / tmp2



//#########################################################
//##################   ENCODING   #########################
//#########################################################
void Encode(FILE *fin , FILE *fout)
{
	FILE	*tmp1 , *tmp2;


	//Burrows-Wheeler Transformation
	BWT	*bwt;
	bwt = new BWT();



	tmp1 = fopen("tmp1" , "wb");
	printf("\nEncoding File...");
	printf("\n1.BurrowsWheelerTransformation");
	bwt->BWT_Encode(fin , tmp1);
	fclose(fin);
	fclose(tmp1);


	//MoveToFront
	MTF	*mtf;
	mtf = new MTF();

	tmp1 = fopen("tmp1" , "rb");
	tmp2 = fopen("tmp2" , "wb");
	printf("\n2.MoveToFront Encoding");
	mtf->MTF_Encode(tmp1 , tmp2);
	fclose(tmp1);
	fclose(tmp2);


	//RunLength Encoding
	RLE	*rle;
	rle = new RLE();

	tmp1 = fopen("tmp2" , "rb");
	tmp2 = fopen("tmp1" , "wb");
	printf("\n3.Run Length Encoding");
	rle->RLE_Encode(tmp1 , tmp2);
	fclose(tmp1);
	fclose(tmp2);


	//Arithmetic Encoding
	printf("\n4.Arithmetic Encoding");

	fin = fopen("tmp1" , "rb");

	ArithmeticCodec	*ari;
	ari = new ArithmeticCodec(fin ,fout);

	ari->StartModel();
	ari->StartOutputingBits();
	ari->StartEncoding();

	//alle Zeichen abarbeiten
	for (;;)
	{
		int ch , symbol;
		//naechstes Zeichen lesen
		ch = getc(fin);

		if (ch == EOF)
			break;

		symbol = arrayCharToIndex[ch];
		ari->EncodeSymbol(symbol,cum_freq);
		ari->UpdateModel(symbol);
	}
	ari->EncodeSymbol(EOF_SYMBOL , cum_freq);
	ari->StopEncoding();
	ari->StopOutputingBits();
	putc( '\n', stderr );



	fclose(fin);
	fclose(fout);
}









//############################################################
//#######################   DECODING #########################
//############################################################
void Decode(FILE *fin , FILE *fout)
{
	FILE	*tmp1 , *tmp2;
	//Arithmetic-decoding :
	
	tmp1 = fopen("tmp1" , "wb");
	printf("\nDecoding File...");
	printf("\n1.Undo Arithmetic Coding");

	
	ArithmeticCodec	*ari2;
	ari2 = new ArithmeticCodec(fin , tmp1);

	ari2->StartModel();
	ari2->StartInputingBits();
	ari2->StartDecoding();
	for (;;)
	{
		int ch , symbol;
		symbol = ari2->DecodeSymbol(cum_freq);

		if (symbol==EOF_SYMBOL)
			break;

		ch = arrayIndexToChar[symbol];
		putc((char) ch , tmp1);
		ari2->UpdateModel(symbol);
	}
	putc( '\n', stderr );

	fclose(fin);
	fclose(tmp1);



	//RunLength Decoding
	RLE	*rle;
	rle = new RLE();
	
	tmp1 = fopen("tmp1" , "rb");
	tmp2 = fopen("tmp2" , "wb");
	printf("\n2.Undo Run Length Coding");
	rle->RLE_Decode(tmp1 , tmp2);
	fclose(tmp1);
	fclose(tmp2);



	//MoveToFront
	MTF	*mtf;
	mtf = new MTF();

	tmp1 = fopen("tmp2" , "rb");
	tmp2 = fopen("tmp1" , "wb");
	printf("\n3.Undo MoveToFront");
	mtf->MTF_Decode(tmp1 , tmp2);
	fclose(tmp1);
	fclose(tmp2);



	//Burrows-Wheeler Transformation
	BWT	*bwt;
	bwt = new BWT();

	tmp1 = fopen("tmp1" , "rb");
	printf("\n4.Undo Burrows-Wheeler Transformation");
	bwt->BWT_Decode(tmp1 , fout);
	fclose(tmp1);
	fclose(fout);
}








//################################################################
int main( int argc, char *argv[] )
{
	FILE	*fin , *fout;

	if (argc > 2)
	{
        fin = fopen( argv[ 1 ], "rb");
        fout = fopen( argv[ 2 ], "wb");
	}
	else
		printf("\nError : Usage : encode [fromfile] [tofile]");


//	Encode(fin , fout);
	Decode(fin , fout);


//	remove("tmp1");
//	remove("tmp2");
	unlink("tmp1");
	unlink("tmp2");

	return 0;
}